# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Private Attributes
dirac::ComponentByteIO Class Reference

Picture component in Dirac bytestream format.

`#include <component_byteio.h>`

Inheritance diagram for dirac::ComponentByteIO:

List of all members.

## Public Member Functions
| ComponentByteIO (CompSort cs, const ByteIO &byteIO)
| Constructor.
| ComponentByteIO (CompSort cs)
| Constructor.
| ~ComponentByteIO ()
| Destructor.
void | CollateByteStats (DiracByteStats &dirac_byte_stats)
| Gathers byte stats on the component data.
void | AddSubband (SubbandByteIO *p_subband_byteio)
| Add a subband byte-stream to this component.
bool | Input ()
| Inputs data from Dirac stream-format.
void | Output ()
| Outputs picture values to Dirac stream-format.
Public Member Functions inherited from dirac::ByteIO
| ByteIO (bool new_stream=true)
| Default constructor.
| ByteIO (const ByteIO &stream_data)
| Constructor.
virtual | ~ByteIO ()
| Destructor.
virtual const std::string | GetBytes ()
| Get bytes in Dirac-bytestream format.
int | GetReadBytePosition () const
| Get position of read stream pointer.
virtual int | GetSize () const
| *Gets size (in bytes)
void | SetByteParams (const ByteIO &byte_io)
| Copies stream source/destination info.
void | ByteAlignOutput ()
| Sync input for byte-alignment.
void | WriteUint (unsigned int value)
| Ouputs an unsigned integer in interleaved exp Golomb format.
void | SetBitsLeft (int left_bits)
| Sets input size in bits.
int | BitsLeft (void)
| Sets input size in bits.

## Private Attributes
CompSort | m_compsort
| Picture component type.
std::vector< ByteIO * > | m_subband_list
| List of subbands in output/input order.

## Additional Inherited Members
Protected Member Functions inherited from dirac::ByteIO
bool | CanRead () const
bool | GetBit (unsigned char &c, int pos) const
void | SetBit (unsigned char &c, int pos) const
void | SetBits (unsigned char &c, unsigned char bits) const
void | ByteAlignInput ()
| Sync input for byte-alignment.
bool | ReadBool ()
| Reads boolean value.
bool | ReadBoolB ()
| Reads boolean value - bounded i/o.
int | ReadBit ()
| Reads next bit.
int | ReadBitB ()
| Reads next bit - bounded i/o.
unsigned int | ReadNBits (int count)
| Reads next 'count' bits.
void | InputBytes (char *data, int count)
| Reads from stream.
void | FlushInputB ()
| Flushes the bounde input.
int | ReadSint ()
| Reads a signed integer in interleaved exp-Golomb format *return Signed integer read.
int | ReadSintB ()
| Reads a signed integer in interleaved exp-Golomb format from bounded input *return Signed integer read.
unsigned int | ReadUint ()
| Reads an unsigned integer in interleaved exp Golomb format.
unsigned int | ReadUintB ()
| Reads an unsigned integer in interleaved exp Golomb format from bounded input.
unsigned int | ReadUintLit (const int byte_size)
| Reads a fixed length unsigned integer from the stream in big endian.
unsigned char | InputUnByte ()
| Reads a byte from the stream.
std::string | InputUnString (const int count)
| Reads a series of bytes from a stream.
void | WriteBit (const bool &bit)
| Outputs a bit.
int | WriteNBits (unsigned int val)
| Outputs an unsigned integer.
void | WriteNBits (unsigned int val, int count)
| Outputs an n bit integer.
void | OutputBytes (const std::string &bytes)
| Outputs a series of bytes.
void | OutputCurrentByte ()
| Outputs current byte contents.
void | WriteSint (int val)
| Outputs an integer in Golomb signed integer format.
void | WriteUintLit (const unsigned int &value, const int &length)
| Output unsigned int value in big endian format.
void | RemoveRedundantBytes (const int count)
| Removes portion of byte-stream no longer required.
void | SeekGet (const int offset, std::ios_base::seekdir dir)
Protected Attributes inherited from dirac::ByteIO
std::stringstream * | mp_stream
| Input/output steam.

## Constructor & Destructor Documentation

dirac::ComponentByteIO::ComponentByteIO | ( | CompSort | cs,
|  | const ByteIO & | byteIO
| ) |  |

Parameters:

  cs | Picture-component type
  byteIO | Input/output Byte stream

dirac::ComponentByteIO::ComponentByteIO | ( | CompSort | cs | ) |

Parameters:

  cs | Picture-component type

dirac::ComponentByteIO::~ComponentByteIO | ( |  | ) |

## Member Function Documentation

void dirac::ComponentByteIO::AddSubband | ( | SubbandByteIO * | p_subband_byteio | ) |

Parameters:

  p_subband_byteio | Subband to be added

void dirac::ComponentByteIO::CollateByteStats | ( | DiracByteStats & | dirac_byte_stats | ) |
| virtual

Parameters:

  dirac_byte_stats | Stat container

Reimplemented from dirac::ByteIO.

bool dirac::ComponentByteIO::Input | ( |  | ) |

void dirac::ComponentByteIO::Output | ( |  | ) |

## Member Data Documentation

CompSort dirac::ComponentByteIO::m_compsort
| private

std::vector<ByteIO*> dirac::ComponentByteIO::m_subband_list
| private

The documentation for this class was generated from the following file:

- component_byteio.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.